<?php

namespace Drupal\vallb\Plugin\Block;

use Drupal\views\Plugin\Block\ViewsBlock;

/**
 * Provides a views lazy built block.
 *
 * @Block(
 *   id = "vallb_block",
 *   admin_label = @Translation("Views lazy built block"),
 *   deriver = "Drupal\views\Plugin\Derivative\ViewsBlock"
 * )
 */
class ViewsLazyBuiltBlock extends ViewsBlock {

  /**
   * {@inheritdoc}
   */
  public function build() {
    $ajax_identifier = $this->view->id() . ':' . $this->displayID;
    $route_parameters = [
      'view' => $this->view->id(),
      'display_id' => $this->displayID,
      'nojs' => 'nojs',
    ];
    $options = [
      'query' => \Drupal::requestStack()->getCurrentRequest()->query->all(),
    ];
    $options['query'] += ['vallb_views_arguments' => []];

    return [
      '#theme' => 'vallb',
      '#ajax_identifier' => $ajax_identifier,
      '#route_parameters' => $route_parameters,
      '#route_options' => $options,
      '#route_name' => 'vallb.lazy_builder',
      '#view' => $this->view,
      '#view_display_id' => $this->displayID,
    ];
  }

}
